﻿Imports System.Data.SqlClient
Imports System.Data
Public Class B4XSQLServer
    Private WithEvents Sock As NetSockets

    Dim WithEvents dr As New dataRoutines
    Private Connectionstring As String
    Private Port As Integer
    Private IP As String
    Private Verbose As Boolean = 0
    Public HostIPAddress As String

    Protected Overrides Sub OnStart(ByVal args() As String)
        Dim pint As Int16
        pint = My.Settings.DebugStartDelaySeconds * 1000
        If pint > 0 Then
            System.Threading.Thread.Sleep(pint)
        End If

        dr = New dataRoutines
        'add delay to give me time to attach to process
        System.Threading.Thread.Sleep(5000)
        Me.Connectionstring = My.Settings.ConnectionString
        Me.Port = My.Settings.UDPReceivePort
        Me.IP = My.Settings.UDPReceiveIP
        Me.Verbose = My.Settings.VerboseEvents
        Sock = New NetSockets(Me.IP, Me.Port, "SOCK1")
        If ConnectToDB() = False Then
            End
        End If
        Sock.LISTEN()
    End Sub
    Private Function ConnectToDB() As Boolean
        Dim tt As New DataTable
        dr.SQLGetDataTable(Me.Connectionstring, "SELECT TOP 1 TRANCODE FROM TRANSACTIONDATA", tt)
        If tt.Rows.Count > 0 Then
            Return True
            dr.AddToLog("Database Connection Success", EventLogEntryType.Information)
        Else
            dr.AddToLog("Database Connection Failed. ", EventLogEntryType.Information)
            Return False
        End If
    End Function
    Protected Overrides Sub OnStop()
        ' Add code here to perform any tear-down necessary to stop your service.
        Sock.STOPLISTERN()

    End Sub

    Private Sub Sock_Data_Arrival(sender As Object, strData As String, IP As String, PORT As Integer, ReturnKey As String) Handles Sock.Data_Arrival
        Dim ts As String
        Dim pint As Integer
        Dim OutData As String = ""
        Dim ERR As Boolean
        Dim EMESSAGE As String = ""
        Dim ccount As Integer = 0
        Dim i As Integer
        Dim EventData As String = ""

        Dim xr As DataRow
        If Verbose Then
            dr.AddToLog("Data Received: " & strData, EventLogEntryType.Information)
        End If
        'GET RID OF MESSAGE DELIMITER IF SENT
        strData = strData.Replace("%", "")
        'CLEAN OUT THE NULL CHARACTERS THAT GET SENT WITH EACH MESSAGE
        strData = strData.Replace(vbNullChar, "")
        Dim tt As New DataTable

        'all commands are treated like they produce a recordset which allows us to run stored procedures etc.
        'Insert and update statements will not produce a return row of data and are handled below.
        If strData <> "" Then
            ERR = dr.SQLGetDataTable(Me.Connectionstring, strData, tt)
        Else
            ERR = 1
        End If

        'nEED TO ADD a row as the first record of this table first row containing rowcount ~ columncount (used to define array to hold data)
        'if table is empty return NODATA~NODATA as first field

        If tt.Rows.Count > 0 Then
            'this was an update or insert statement that returned no response.
            'NEED TO RETURN AT LEAST 3 COLUMNS column  0 = number of rows, column1 = number of columns, column3 = returnkey so b4x knows what to do with the 
            'data on return.
            ccount = tt.Columns.Count + 1
            For i = ccount To 3
                ts = "Dummy" & ccount.ToString
                Dim C As New DataColumn(ts, GetType(String))
                tt.Columns.Add(C)
                tt.AcceptChanges()
            Next
            xr = tt.NewRow
            ' ts = tt.Rows.Count.ToString & "~" & tt.Columns.Count.ToString & "~" & ReturnKey
            xr(0) = tt.Rows.Count.ToString
            xr(1) = tt.Columns.Count.ToString
            xr(2) = ReturnKey
            tt.Rows.InsertAt(xr, 0)
            tt.AcceptChanges()
            EventData = "SQL Returned Data"
        Else
            'this queried returned data from the sql statement
            If ERR Then
                'sql statement failed
                OutData = "0~NO DATA SQL ERROR~" & ReturnKey
                EventData = "Invalid SQL Statement"

            Else
                'the sql statement did not error but did not return a value.  Assume it worked and send a success response
                OutData = "1~OK~" & ReturnKey
                EventData = "SQL Statement Did not Error but returned no Data"

            End If
            GoTo NODATA


        End If

        'BUILD OUTPUT STRING FROM TABLE CREATED
        'add the first record with data to outdata

        ccount = tt.Columns.Count

        For Each xr In tt.Rows
            ts = ""
            For i = 0 To (ccount - 1)
                ts += xr(i).ToString & "~"
            Next
            pint = ts.LastIndexOf("~")
            ts = ts.Substring(0, pint)
            OutData = OutData & ts & vbLf

        Next
        EventData = "SQL Statement Returned Table Data"
        ' pint = OutData.LastIndexOf(Chr(10))
        '  OutData = OutData.Substring(0, pint)
        ' OutData += "%%"

NODATA:
        dr.AddToLog(EventData, EventLogEntryType.Information)
        sender.UDPSENDER(OutData, IP, PORT)
    End Sub

    Private Sub Sock_ErrorEvent(sender As Object, ex As Exception) Handles Sock.ErrorEvent
        dr.AddToLog("Error Occurred in UDPSOCK", EventLogEntryType.Error)
        End
    End Sub
End Class
