﻿
Imports System.Net.Sockets
Imports System.Threading
Imports System.Text
Imports System.Net
Public Class NetSockets
    Inherits EventArgs
    Dim MSOCK As New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
    Public Delegate Sub DataArrivalHandler(ByVal sender As Object, ByVal strData As String, IP As String, PORT As Integer, ReturnKey As String)
    Public Event Data_Arrival As DataArrivalHandler
    Public Delegate Sub ErrorEventHandler(ByVal sender As Object, ByVal ex As Exception)
    Public Event ErrorEvent As ErrorEventHandler
    Public SockName As String
    Private strIPADDRESS As String
    Private intLOCALPORT As Int32
    Private intHOSTPORT As Int32
    Private strHOSTIPADDRESS As String = 10011
    Private strDATAOUT As String
    Private BoolKillAfterReceive As Boolean = True
    Private ProcThread As Threading.Thread
    Private ts As Threading.Thread

    Public Sub New(ByVal LocalAddress As String, ByVal LocalPort As Int32, ByVal _SockName As String)
        strIPADDRESS = LocalAddress
        intLOCALPORT = LocalPort
        SockName = _SockName

    End Sub

    Private Property DataOut() As String
        Get
            DataOut = strDATAOUT
        End Get
        Set(ByVal Value As String)
            strDATAOUT = Value
        End Set
    End Property
    Property HostIPAddress() As String
        Get
            HostIPAddress = strHOSTIPADDRESS
        End Get
        Set(ByVal Value As String)
            strHOSTIPADDRESS = Value
        End Set
    End Property
    Property LocalIPAddress() As String
        Get
            LocalIPAddress = strIPADDRESS
        End Get
        Set(ByVal Value As String)
            strIPADDRESS = Value
        End Set
    End Property
    Property LocalPort() As Int32
        Get
            LocalPort = intLOCALPORT
        End Get
        Set(ByVal Value As Int32)
            intLOCALPORT = Value
        End Set
    End Property

    Property HostPort() As Int32
        Get
            HostPort = intHOSTPORT
        End Get
        Set(ByVal Value As Int32)
            intHOSTPORT = Value
        End Set
    End Property
    Property KillAfterReceive() As Boolean
        Get
            KillAfterReceive = BoolKillAfterReceive
        End Get
        Set(ByVal Value As Boolean)
            BoolKillAfterReceive = Value
        End Set
    End Property
    Sub LISTEN()
        ts = New Threading.Thread(AddressOf UDPListenerOn)
        ts.Start()

    End Sub
    Sub STOPLISTERN()

        MSOCK.Close()
    End Sub
    Private Sub ProcessSocket(Data As String)
        Dim pint As Integer
        Dim arr As Array

        Dim i As Integer
        Dim bytes(i) As [Byte]
        Dim replydata As String
        Dim ip As String
        Dim port As String
        Dim ReturnKey As String
        Try
            'added for testing
            If Data.Contains(Chr(10)) = False Then
                Data += Chr(10)
            End If



            replydata = Data.Substring(0, InStr(Data, Chr(10)) - 1)
            'below added to dummy up reply socket of socket tester
            '--------------------------------------------------------------
            'first line contains ip and port ends with a char(10) delimited with a :
            'replydata = "192.168.88.206:10002:returnkey"
            arr = replydata.Split(":")
            ip = arr(0)
            port = arr(1)
            ReturnKey = arr(2)
            pint = Data.IndexOf(Chr(10))
            Data = Data.Substring(pint + 1)
            If Data.ToUpper = "DEMODEMO" Then
                UDPSENDER("Connection To Server Successfull", ip, port)
            End If

            'added for testing from socket tester
            ' pint = 0
            ' Data += Chr(10)
            '--------------------------------------------------------------
            If pint = -1 Then
                'invlalid data.  do nothing
                RaiseEvent Data_Arrival(Me, "Invalid Data", "", 0, ReturnKey)
            Else
                RaiseEvent Data_Arrival(Me, Data, arr(0), CType(arr(1), Integer), ReturnKey)
            End If
        Catch ex As Exception
            RaiseEvent ErrorEvent(Me, ex)
        End Try


    End Sub
    Private Sub UDPListenerOn()
        Try

            MSOCK = New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
            MSOCK.ReceiveBufferSize = 4096
            MSOCK.SendBufferSize = 64000
            Dim mip As Net.IPAddress = IPAddress.Parse(strIPADDRESS)
            Dim MEP As New Net.IPEndPoint(mip, intLOCALPORT)
            MSOCK.Bind(MEP)
            Dim i As Int32 = 2048
            Dim bytes(i) As [Byte]
            Dim sbytes As [Byte]() = Encoding.ASCII.GetBytes("REPLY")
            Dim data As String = ""

            Do While True
                If MSOCK.Available > 0 Then
                    MSOCK.Receive(bytes)
                    data = System.Text.Encoding.ASCII.GetString(bytes, 0, i)
                    ProcThread = New Thread(AddressOf ProcessSocket)
                    ProcThread.Start(data)

                End If
                System.Threading.Thread.Sleep(10)
            Loop
        Catch ex As Exception
            RaiseEvent ErrorEvent(Me, ex)
        End Try
        MSOCK.Close()
        MSOCK.Dispose()
        UDPListenerOn()
    End Sub
    'Sub UDPSENDER(ByVal strdataout As String)
    '    Try
    '        Dim mip As Net.IPAddress = IPAddress.Parse(strHOSTIPADDRESS)
    '        Dim MEP As New Net.IPEndPoint(mip, intHOSTPORT)
    '        Dim MSOCK As New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
    '        Dim sbytes As [Byte]() = Encoding.ASCII.GetBytes(strdataout)
    '        MSOCK.SendTo(sbytes, MEP)

    '    Catch ex As Exception
    '        RaiseEvent ErrorEvent(Me, ex)
    '    End Try
    'End Sub
    Sub UDPSENDER(ByVal strdataout As String, ToIPAddress As String, ToPort As Integer)
        Try
            Dim mip As Net.IPAddress = IPAddress.Parse(ToIPAddress)
            Dim MEP As New Net.IPEndPoint(mip, ToPort)
            Dim MSOCK As New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
            MSOCK.SendBufferSize = 64000
            Dim sbytes As [Byte]() = Encoding.ASCII.GetBytes(strdataout)
            MSOCK.SendTo(sbytes, MEP)

        Catch ex As Exception
            RaiseEvent ErrorEvent(Me, ex)
        End Try
    End Sub
    'Public Sub onData_Arrival(ByVal sender As Object, ByVal strData As String)

    '    Dim del As DataArrivalHandler = Me.Data_ArrivalEvent

    '    If (Not del Is Nothing) Then

    '        Dim SafeInvoker As System.ComponentModel.ISynchronizeInvoke = Nothing

    '        Try

    '            SafeInvoker = DirectCast(del.Target, System.ComponentModel.ISynchronizeInvoke)

    '        Catch

    '        End Try

    '        If (Not SafeInvoker Is Nothing) Then

    '            SafeInvoker.Invoke(del, New Object() {sender, strData})

    '        Else

    '            del.Invoke(sender, strData)

    '        End If



    '    End If

    'End Sub


End Class
